'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FlagIconOptionsType = exports.FlagIconPropsType = exports.FlagIconClassesObjectType = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _countries = require('../functions/countries');

var _propTypes3 = require('../functions/propTypes');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FlagIconSizeType = _propTypes2.default.oneOf(['lg', '2x', '3x', '4x', '5x']);
var FlagIconRotateType = _propTypes2.default.oneOf([30, 60, 90, 180, 270]);
var FlagIconFlipType = _propTypes2.default.oneOf(['horizontal', 'vertical']);
var FlagIconCodeType = _propTypes2.default.oneOf((0, _countries.getCountryCodes)());

var FlagIconClassesObject = {
  code: FlagIconCodeType.isRequired,
  size: FlagIconSizeType,
  squared: _propTypes2.default.bool,
  rotate: FlagIconRotateType,
  flip: FlagIconFlipType
};
var FlagIconPropsTypeObject = _extends({}, FlagIconClassesObject, {
  children: _propTypes2.default.element,
  Component: _propTypes2.default.string
});

var FlagIconClassesObjectType = exports.FlagIconClassesObjectType = (0, _propTypes3.AddExactValidator)(FlagIconClassesObject);
var FlagIconPropsType = exports.FlagIconPropsType = (0, _propTypes3.AddExactValidator)(FlagIconPropsTypeObject);

var FlagIconOptionsType = exports.FlagIconOptionsType = (0, _propTypes3.AddExactValidator)({
  useCssModules: _propTypes2.default.bool,
  themeStyles: _propTypes2.default.object
});