var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import PropTypes from 'prop-types';
import { getCountryCodes } from '../functions/countries';
import { AddExactValidator } from '../functions/propTypes';

var FlagIconSizeType = PropTypes.oneOf(['lg', '2x', '3x', '4x', '5x']);
var FlagIconRotateType = PropTypes.oneOf([30, 60, 90, 180, 270]);
var FlagIconFlipType = PropTypes.oneOf(['horizontal', 'vertical']);
var FlagIconCodeType = PropTypes.oneOf(getCountryCodes());

var FlagIconClassesObject = {
  code: FlagIconCodeType.isRequired,
  size: FlagIconSizeType,
  squared: PropTypes.bool,
  rotate: FlagIconRotateType,
  flip: FlagIconFlipType
};
var FlagIconPropsTypeObject = _extends({}, FlagIconClassesObject, {
  children: PropTypes.element,
  Component: PropTypes.string
});

export var FlagIconClassesObjectType = AddExactValidator(FlagIconClassesObject);
export var FlagIconPropsType = AddExactValidator(FlagIconPropsTypeObject);

export var FlagIconOptionsType = AddExactValidator({
  useCssModules: PropTypes.bool,
  themeStyles: PropTypes.object
});